// GetInfoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GetInfo.h"
#include "GetInfoDlg.h"

#include "act.h"
#include "actflds.h"
#include <stdio.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetInfoDlg dialog

CGetInfoDlg::CGetInfoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetInfoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGetInfoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGetInfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGetInfoDlg)
	DDX_Control(pDX, IDC_LIST1, m_ListBox);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGetInfoDlg, CDialog)
	//{{AFX_MSG_MAP(CGetInfoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONTACT, OnContact)
	ON_BN_CLICKED(IDC_GROUP, OnGroup)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetInfoDlg message handlers

BOOL CGetInfoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGetInfoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGetInfoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGetInfoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGetInfoDlg::OnContact() 
{
		COleException *pException;
		
	try
	{		
		IActAppObj AppObj;	
		IAIViews Views ;
		IAIContactView CView ;
		IAIGrid Grid ;
        CString Contactid ;
        
		m_ListBox.ResetContent() ;

		//Create the Application object dispatch pointer
		AppObj.CreateDispatch("ACTOLE.APPOBJECT", pException);
		
		//Create the Views dispatch pointer
	   	LPDISPATCH viewsDispatch = AppObj.Views();
		Views.AttachDispatch(viewsDispatch, TRUE);
        
		//Create the ContactView Dispatch pointer
		LPDISPATCH CVDispatch = Views.Create(1,"CView");
         CView.AttachDispatch(CVDispatch, TRUE);
         Contactid = CView.GetCurrentID() ;
		
		 //List the Current Contact Information
        m_ListBox.AddString("Current Contact Information");
		m_ListBox.AddString(CView.GetField (CF_Name) );
		m_ListBox.AddString(CView.GetField (CF_Company) );
		m_ListBox.AddString(CView.GetField (CF_Title) );
		m_ListBox.AddString("Phone: " + CView.GetField (CF_Phone) );
		m_ListBox.AddString("Ticker Symbol: " + CView.GetField (CF_TickerSymbol) );
        
		//Set Activities to be the Active Tab
		CView.SetActiveTab ("Activities") ;

		//Create the Activities Grid Dispatch pointer

		LPDISPATCH GridDispatch = CView.Activities() ;
        Grid.AttachDispatch(GridDispatch, TRUE);
        int i = 0 ;
		if (Grid.GetRowCount() > 0)
		{
			//List all the Activities
			Grid.MoveFirst() ;
			while (i < Grid.GetRowCount())
			{
				m_ListBox.AddString("StartTime: " + Grid.GetField (AF_StartTime,i) + " Regarding :" + Grid.GetField (AF_Regarding,i) + " Duration : "+ Grid.GetField (AF_Duration ,i));
				i++ ;
			}
		}
		else 
				m_ListBox.AddString ("There are no Activities");

		//Release all the dispatch pointers
        Grid.ReleaseDispatch() ;
		CView.ReleaseDispatch();
		Views.ReleaseDispatch();
		AppObj.ReleaseDispatch();
	}
	catch(...)
	{
		TRACE("Detected Exception in CTest1View::OnContact() \n");		
		AfxMessageBox("Detected Exception in CTest1View::OnContact ");
	}	
}	
	
	


void CGetInfoDlg::OnGroup() 
{
		
		COleException *pException;
		
	try
	{		
		IActAppObj AppObj;	
		IAIViews Views ;
		IAIGroupView GView ;
		IAIGrid Grid ;
		
        
        m_ListBox.ResetContent() ;
		//Create the Application object dispatch pointer
		AppObj.CreateDispatch("ACTOLE.APPOBJECT", pException);
		
		//Create the Views dispatch pointer
	   	LPDISPATCH viewsDispatch = AppObj.Views();
		Views.AttachDispatch(viewsDispatch, TRUE);
        
		//Create the GroupView Dispatch Pointer
		LPDISPATCH GVDispatch = Views.Create(3,"GView");
         GView.AttachDispatch(GVDispatch, TRUE);

        //List the Current Group Information
        m_ListBox.AddString("Current Group Information");
		m_ListBox.AddString("Name : " + GView.GetField (GF_Name) );
		m_ListBox.AddString("City : " + GView.GetField (GF_City) );
		m_ListBox.AddString("State: " + GView.GetField (GF_State) );
		m_ListBox.AddString("Number of Contacts in the Group :" + GView.GetField (GF_TotalInGroup) );
        m_ListBox.AddString("Contacts in the Group are :");
        //List the Contacts in the Group
		//Create the ContactMembers Grid Dispatch pointer
		GView.SetActiveTab ("Contacts");
		LPDISPATCH GridDispatch = GView.ContactMembers() ;
        Grid.AttachDispatch(GridDispatch, TRUE);
        int i = 0 ;
		if (Grid.GetRowCount() > 0)
		{
			//List all the Contacts
			Grid.MoveFirst() ;
			while (i < Grid.GetRowCount())
			{	
				m_ListBox.AddString(Grid.GetField (CF_Name,i) );
				i++ ;
			}
		}
		else 
				m_ListBox.AddString ("There are no Contacts in this Group");

		//Release all the dispatch pointers
        Grid.ReleaseDispatch() ;

		//Release all dispatch pointers
	
		GView.ReleaseDispatch();
		Views.ReleaseDispatch();
		AppObj.ReleaseDispatch();
	}
	catch(...)
	{
		TRACE("Detected Exception in CTest1View::OnGroup() \n");		
		AfxMessageBox("Detected Exception in CTest1View::OnGroup ");
	}	
	
	
}
