
// Contact Field Unique IDs
#define CF_UniqueID  1
#define CF_CreateTimestamp  2
#define CF_EditTimestamp  3
#define CF_MergeTimestamp  4
#define CF_PublicPrivate  5
#define CF_RecordManager  6
#define CF_Company  25
#define CF_Name  26
#define CF_Address1  27
#define CF_Address2  28
#define CF_Address3  29
#define CF_City  30
#define CF_State  31
#define CF_Zip  32
#define CF_Country  33
#define CF_IDStatus  34
#define CF_Phone  35
#define CF_Fax  36
#define CF_HomePhone  37
#define CF_MobilePhone  38
#define CF_Pager  39
#define CF_Salutation  40
#define CF_LastMeet  41
#define CF_LastReach  42
#define CF_LastAttempt  43
#define CF_LetterDate  44
#define CF_Unused1  45
#define CF_Title  46
#define CF_Assistant  47
#define CF_LastResults  48
#define CF_ReferredBy  49
#define CF_User1  50
#define CF_User2  51
#define CF_User3  52
#define CF_User4  53
#define CF_User5  54
#define CF_User6  55
#define CF_User7  56
#define CF_User8  57
#define CF_User9  58
#define CF_User10  59
#define CF_User11  60
#define CF_User12  61
#define CF_User13  62
#define CF_User14  63
#define CF_User15  64
#define CF_AltAddress1  65
#define CF_AltAddress2  66
#define CF_AltCity  67
#define CF_AltState  68
#define CF_AltZip  69
#define CF_AltCountry  70
#define CF_AltPhone  71
#define CF_Name2  72
#define CF_Title2  73
#define CF_Phone2  74
#define CF_Name3  75
#define CF_Title3  76
#define CF_Phone3  77
#define CF_FirstName  78
#define CF_LastName  79
#define CF_Ext  80                   // the work phone extension
#define CF_FaxExt  81                // the fax extension
#define CF_AltPhoneExt  82           // alternate phone extension
#define CF_Phone2Ext  83             // contact 2 phone extension
#define CF_Phone3Ext  84             // contact 3 phone extension
#define CF_AsstTitle  85             // the assistants title
#define CF_AsstPhone  86             // the assistant phone
#define CF_AsstExt  87               // the assistant extension
#define CF_Department  88            // the contacts department
#define CF_Spouse  89                // the contacts spouse name
#define CF_Creator  90               // the creator of the record
#define CF_UsersCompany  91          // equivalent to the ACT! 2.0 Owner field (the company of the user that owns the record)
#define CF_Alt1Reach  92             // alternate contact 1 last reach (for ACT! 2.0 compatability)
#define CF_Alt2Reach  93             // alternate contact 2 last reach (for ACT! 2.0 compatability)
#define CF_URL  94                   // URL or web site address
#define CF_TickerSymbol  95          // Ticker Symbol (Available in ACT4.0 databases only)
#define CF_ContactType  125
#define CVF_EmailAddress  200        // for display of e-mail address
#define CVF_Note  201                // for "import" of note
#define CVF_EmailLogon  202          // separate components for e-mail logon
#define CVF_EmailCarrier  203        // separate component for e-mail carrier


// Group Field Unique IDs
#define GF_UniqueID  1
#define GF_CreateTimestamp  2
#define GF_EditTimestamp  3
#define GF_MergeTimestamp  4
#define GF_PublicPrivate  5
#define GF_RecordManager  6
#define GF_Name  25
#define GF_Division  26
#define GF_Address1  27
#define GF_Address2  28
#define GF_Address3  29
#define GF_City  30
#define GF_State  31
#define GF_Zip  32
#define GF_Country  33
#define GF_Priority  35
#define GF_User1  36
#define GF_User2  37
#define GF_User3  38
#define GF_User4  39
#define GF_Description  40
#define GF_User5  47
#define GF_User6  48      // extra user field
#define GF_Creator  54    // the creator of the record
#define GF_ParentId  55
#define GF_GroupLevel  56
#define GF_Region    57
#define GF_Industry  58
#define GF_SicCode   59
#define GF_Employees 60
#define GF_Revenue   61
#define GF_TotalInGroup  100
#define GVF_Note  200


// Activity Field Unique IDs
#define AF_UniqueID  1
#define AF_CreateTimestamp  2
#define AF_EditTimestamp  3
#define AF_MergeTimestamp  4
#define AF_PublicPrivate  5
#define AF_Type  25
#define AF_Priority  26
#define AF_Regarding  27
#define AF_StartTime  28       // the starting time of the series of activities
#define AF_EndTime  29         // the ending time of the series of activities
#define AF_Duration  30        // the duration of a single instance of the activity
#define AF_TimelessStatus  31
#define AF_LeadTime  32
#define AF_AlarmStatus  33
#define AF_BannerColor  34
#define AF_EmailStatus  35
#define AF_Recurring  36
#define AF_ScheduledFor  37
#define AF_ScheduledBy  38
#define AF_GroupId  39
#define AF_FirstScheduledWith  40   // the first scheduled with (for performance purposes)
#define AF_ClearedStatus  41        // the cleared status of this activity
#define AF_RecurringId  42          // unique id of this recurring chain
#define AF_Exceptions  43           // recurring exception list (stored as a blob)
#define AF_ExceptionDate  44
#define AF_Details        45
#define AF_RecordStatus   46
#define AF_ExternalId     47
#define AF_TotalInActivity  100
#define AF_TotalDuration  101       // total duration of the activity series in minutes
#define AVF_ScheduledDate  200
#define AVF_ScheduledTime  201



// Note/History Field Unique IDs
#define NHF_UniqueID  1
#define NHF_CreateTimestamp  2
#define NHF_EditTimestamp  3
#define NHF_MergeTimestamp  4
#define NHF_Type  25
#define NHF_Text  26
#define NHF_UserTime  27
#define NHF_Attachment  28
#define NHF_ContactId  29
#define NHF_GroupId  30
#define NHF_ActivityId  31
#define NHVF_RecordedDate  200
#define NHVF_RecordedTime  201


// EMAIL Field Unique IDs
#define EF_UniqueID  1
#define EF_CreateTimestamp  2
#define EF_EditTimestamp  3
#define EF_MergeTimestamp  4
#define EF_Logon  25
#define EF_Carrier  26
#define EF_PrimaryStatus  27
#define EF_ContactId  28

// SALES Field Unique IDs
#define SLF_UniqueID  1
#define SLF_CreateTimestamp  2
#define SLF_EditTimestamp  3
#define SLF_MergeTimestamp  4
#define SLF_ContactId   25
#define SLF_GroupId   26
#define SLF_Status   27
#define SLF_ProductId   28
#define SLF_TypeId   29
#define SLF_Probability   30
#define SLF_SaleDate   31
#define SLF_Units   32
#define SLF_UnitPrice   33
#define SLF_Amount   34
#define SLF_SaleStartDate   35
#define SLF_Notes   36
#define SLF_CompetitorsId   37
#define SLF_Reason   38
#define SLVF_ProductName   200
#define SLVF_TypeName      201
#define SLVF_Competitors   202


// LIST Table Unique IDs
#define LTF_UniqueID  1
#define LTF_Type     25
#define LTF_Name     26