// Machine generated IDispatch wrapper class(es) created with ClassWizard
/////////////////////////////////////////////////////////////////////////////
// IDatabase wrapper class

class IDatabase : public COleDispatchDriver
{
public:
	IDatabase() {}		// Calls COleDispatchDriver default constructor
	IDatabase(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IDatabase(const IDatabase& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetName();
	BOOL GetIsOpen();
	BOOL GetIsMultiUser();
	short GetActiveUserCount();
	LPDISPATCH GetContact();
	LPDISPATCH GetActivity();
	LPDISPATCH GetEmail();
	LPDISPATCH GetGroup();
	LPDISPATCH GetNoteHistory();
	LPDISPATCH GetSales();
	LPDISPATCH GetListTable();
	LPDISPATCH GetUsers();
	LPDISPATCH GetRelations();
	BOOL GetError();
	short GetLastError();
	CString GetCurrentUser();
	BOOL GetIsOpening();
	BOOL GetLogTransactions();
	void SetLogTransactions(BOOL);
	short GetPhoneFormatting();
	void SetPhoneFormatting(short);
	LPDISPATCH GetNewGroup();
	LPDISPATCH GetNewContact();
	LPDISPATCH GetNewActivity();
	short GetMajorVersion();
	short GetMinorVersion();
	short GetTableCount();
	CString GetActVersion();
	CString GetVersion();
	CString GetDatabaseVersion();
	BOOL GetIsLocked();
	BOOL GetIsInBatchMode();

// Operations
public:
	void Open(LPCTSTR sDatabaseName);
	void OpenEx(LPCTSTR sDatabaseName);
	void Close();
	CString GetUniqueId();
	void ValidateUser(LPCTSTR sUser, LPCTSTR sPassword);
	short GetTableID(short nIndex);
	CString GetTableNameFromID(short nID);
	CString GetTableNameFromIndex(short nIndex);
	CString GetDatabasePath();
	BOOL Lock();
	BOOL Unlock();
	BOOL BeginBatchInsert(short nBatchFlag);
	BOOL EndBatchInsert();
	BOOL BeginBatchUpdate(short nBatchFlag);
	BOOL EndBatchUpdate();
	CString GetActiveUsers(BOOL fIncludeCurrent);
};
/////////////////////////////////////////////////////////////////////////////
// IContact wrapper class

class IContact : public COleDispatchDriver
{
public:
	IContact() {}		// Calls COleDispatchDriver default constructor
	IContact(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IContact(const IContact& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetPosition();
	BOOL GetError();
	short GetLastError();
	CString GetName();
	LPDISPATCH GetFields();
	short GetFieldCount();
	long GetRecordCount();
	BOOL GetIsBOF();
	BOOL GetIsEOF();
	BOOL GetIsOpen();
	BOOL GetIsLocked();
	short GetLockLevel();

// Operations
public:
	void MoveFirst();
	void MoveLast();
	void MovePrevious();
	void MoveNext();
	void Close();
	void GoTo(LPCTSTR sUniqueId);
	void Lookup(short nField, LPCTSTR sKeyword, short nlookupType);
	void Sort(short nField1, short nDirection1, short nField2, short nDirection2, short nField3, short nDirection3);
	short GetSort(short* nField1, short* nDirection1, short* nField2, short* nDirection2, short* nField3, short* nDirection3);
	void Add();
	void Delete();
	void Edit();
	void Open();
	CString Update();
	void Rebuild();
	VARIANT GetData(short nField);
	void SetData(short nField, const VARIANT& newValue);
	CString GetQuery();
	void SetQuery(LPCTSTR lpszNewValue);
	void Execute();
	void Jump(long nIndex);
	SCODE LoadLookupQuery(LPCTSTR lpszFileName);
	void SetAsMyRecord(LPCTSTR lpszUserLoginName);
	void GetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	void SetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	BOOL GetStats(short nScopeType, LPCTSTR lpszUniqueId, const VARIANT& vFieldArray, const VARIANT& vValueArray, const VARIANT& vCountArray);
	void LookupKeyword(LPCTSTR sKeyword);
	void LookupMyRecord();
	void SetDuplicateCriteria(short nFieldId1, short nFieldId2, short nFieldId3);
	void GetDuplicateCriteria(short* nFieldId1, short* nFieldId2, short* nFieldId3);
	void FindDuplicates();
};
/////////////////////////////////////////////////////////////////////////////
// IActivity wrapper class

class IActivity : public COleDispatchDriver
{
public:
	IActivity() {}		// Calls COleDispatchDriver default constructor
	IActivity(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IActivity(const IActivity& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetPosition();
	CString GetName();
	BOOL GetIsOpen();
	short GetFieldCount();
	long GetRecordCount();
	BOOL GetIsLocked();
	short GetLockLevel();
	BOOL GetError();
	short GetLastError();
	CString GetFirstScheduledWith();
	void SetFirstScheduledWith(LPCTSTR);
	CString GetNextScheduledWith();
	void SetNextScheduledWith(LPCTSTR);
	BOOL GetIsBOF();
	BOOL GetIsEOF();
	LPDISPATCH GetFields();
	short GetRecurringType();
	LPDISPATCH GetExceptionInfo();
	BOOL GetRecurringChangeMode();
	void SetRecurringChangeMode(BOOL);
	BOOL GetIsOutlookActivity();
	long GetRecordStatus();
	void SetRecordStatus(long);

// Operations
public:
	void Open();
	void Close();
	void MoveFirst();
	void MoveLast();
	void MoveNext();
	void MovePrevious();
	void GoTo(LPCTSTR sUniqueId);
	void Lookup(short nField, LPCTSTR sKeyword, short nlookupType);
	void Sort(short nField1, short nDirection1, short nField2, short nDirection2, short nField3, short nDirection3);
	short GetSort(short* nField1, short* nDirection1, short* nField2, short* nDirection2, short* nField3, short* nDirection3);
	void Add();
	void Edit();
	CString Update();
	void Delete();
	VARIANT GetData(short nField);
	void SetData(short nField, const VARIANT& newValue);
	void Jump(long nIndex);
	void Rebuild();
	BOOL Clear();
	BOOL UnClear();
	BOOL IsClear();
	BOOL IsRecurring();
	BOOL IsTimeless();
	BOOL HasAlarm();
	void SetDateScope(const VARIANT& startDate, const VARIANT& endDate);
	void ClearDateScope();
	void SetTypeFilter(short type);
	void ClearTypeFilter();
	void SetPriorityFilter(short priority);
	void ClearPriorityFilter();
	void SetTimelessFilter();
	void ClearTimelessFilter();
	void SetTimedFilter();
	void ClearTimedFilter();
	void SetClearedFilter();
	void ClearClearedFilter();
	void SetUnclearedFilter();
	void ClearUnclearedFilter();
	void SetGroupScope(LPCTSTR sGroupUniqueID);
	void ClearGroupScope();
	void SetContactScope(LPCTSTR sContactUniqueID);
	void ClearContactScope();
	void SetRecurringDays(long frequency, const VARIANT& untilDateParm);
	void SetRecurringWeekDays(long frequency, long daybits, const VARIANT& untilDateParm);
	void SetRecurringDaysAndWeeksofMonth(long frequency, long daybits, long weekBits, const VARIANT& untilDateParm);
	void ClearRecurring();
	long GetWeeksOfMonthBits();
	long GetDaysOfWeekBits();
	short GetRecurringFrequency();
	VARIANT GetRecurringUntilDate();
	long GetDaysOfMonthBits();
	void SetRecurringDaysOfMonth(long frequency, long daysOfMonthBits, const VARIANT& untilDateParm);
	void SetTimeless(BOOL bTimeless);
	CString GetQuery();
	void SetQuery(LPCTSTR lpszNewValue);
	void Execute();
	void GetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	void SetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	BOOL GetStats(short nScopeType, LPCTSTR lpszUniqueId, const VARIANT& vFieldArray, const VARIANT& vValueArray, const VARIANT& vCountArray);
	BOOL HasDetails();
};
/////////////////////////////////////////////////////////////////////////////
// IEmail wrapper class

class IEmail : public COleDispatchDriver
{
public:
	IEmail() {}		// Calls COleDispatchDriver default constructor
	IEmail(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IEmail(const IEmail& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetPosition();
	CString GetName();
	BOOL GetIsOpen();
	short GetFieldCount();
	long GetRecordCount();
	BOOL GetIsLocked();
	short GetLockLevel();
	BOOL GetError();
	short GetLastError();
	BOOL GetIsBOF();
	BOOL GetIsEOF();
	LPDISPATCH GetFields();

// Operations
public:
	void Open();
	void Close();
	void MoveFirst();
	void MoveLast();
	void MoveNext();
	void MovePrevious();
	void GoTo(LPCTSTR sUniqueId);
	void Lookup(short nField, LPCTSTR sKeyword, short nlookupType);
	void Sort(short nField1, short nDirection1, short nField2, short nDirection2, short nField3, short nDirection3);
	short GetSort(short* nField1, short* nDirection1, short* nField2, short* nDirection2, short* nField3, short* nDirection3);
	void Add();
	void Edit();
	CString Update();
	void Delete();
	VARIANT GetData(short nField);
	void SetData(short nField, const VARIANT& newValue);
	void Jump(long nIndex);
	void Rebuild();
	CString GetQuery();
	void SetQuery(LPCTSTR lpszNewValue);
	void Execute();
	void SetContactScope(LPCTSTR sUniqueId);
	void ClearContactScope();
	void GetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	void SetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	BOOL GetStats(short nScopeType, LPCTSTR lpszUniqueId, const VARIANT& vFieldArray, const VARIANT& vValueArray, const VARIANT& vCountArray);
	void LookupKeyword(LPCTSTR sKeyword);
};
/////////////////////////////////////////////////////////////////////////////
// IGroup wrapper class

class IGroup : public COleDispatchDriver
{
public:
	IGroup() {}		// Calls COleDispatchDriver default constructor
	IGroup(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IGroup(const IGroup& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetPosition();
	long GetContactCount();
	BOOL GetError();
	short GetFieldCount();
	BOOL GetIsLocked();
	BOOL GetIsOpen();
	short GetLastError();
	short GetLockLevel();
	CString GetName();
	long GetRecordCount();
	LPDISPATCH GetMembers();
	void SetMembers(LPDISPATCH);
	BOOL GetIsBOF();
	BOOL GetIsEOF();
	LPDISPATCH GetFields();

// Operations
public:
	void Add();
	void AddContact(LPCTSTR sUniqueId);
	void Close();
	VARIANT GetData(short nField);
	void SetData(short nField, const VARIANT& newValue);
	void Delete();
	void Edit();
	void GoTo(LPCTSTR sUniqueId);
	void Lookup(short nField, LPCTSTR sKeyword, short nlookupType);
	void Sort(short nField1, short nDirection1, short nField2, short nDirection2, short nField3, short nDirection3);
	void MoveFirst();
	void MoveLast();
	void MoveNext();
	void MovePrevious();
	void Open();
	void RemoveContact(LPCTSTR sUniqueId);
	CString Update();
	CString GetQuery();
	void SetQuery(LPCTSTR lpszNewValue);
	void Execute();
	void Jump(long nIndex);
	void Rebuild();
	void SetContactScope(LPCTSTR sUniqueId);
	void ClearContactScope();
	void GetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	void SetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	BOOL GetStats(short nScopeType, LPCTSTR lpszUniqueId, const VARIANT& vFieldArray, const VARIANT& vValueArray, const VARIANT& vCountArray);
	void LookupKeyword(LPCTSTR sKeyword);
	long GetSubGroupCount();
	CString GetSubGroup(short nSubIndex);
	void AddSubGroup();
	BOOL AssignParent(LPCTSTR sParentUniqueId);
	CString GetParent();
	short GroupType();
	BOOL ChangeToSubGroup(LPCTSTR sParentUniqueId);
	BOOL ChangeToParentGroup();
	LPDISPATCH GetSubGroupList();
	void SetDuplicateCriteria(short nFieldId1, short nFieldId2, short nFieldId3);
	void GetDuplicateCriteria(short* nFieldId1, short* nFieldId2, short* nFieldId3);
	void FindDuplicates();
};
/////////////////////////////////////////////////////////////////////////////
// INoteHistory wrapper class

class INoteHistory : public COleDispatchDriver
{
public:
	INoteHistory() {}		// Calls COleDispatchDriver default constructor
	INoteHistory(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	INoteHistory(const INoteHistory& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetPosition();
	CString GetName();
	BOOL GetIsOpen();
	short GetFieldCount();
	long GetRecordCount();
	BOOL GetIsLocked();
	short GetLockLevel();
	BOOL GetError();
	short GetLastError();
	BOOL GetIsBOF();
	BOOL GetIsEOF();
	LPDISPATCH GetFields();

// Operations
public:
	void Open();
	void Close();
	void MoveFirst();
	void MoveLast();
	void MoveNext();
	void MovePrevious();
	void GoTo(LPCTSTR sUniqueId);
	void Lookup(short nField, LPCTSTR sKeyword, short nlookupType);
	void Sort(short nField1, short nDirection1, short nField2, short nDirection2, short nField3, short nDirection3);
	short GetSort(short* nField1, short* nDirection1, short* nField2, short* nDirection2, short* nField3, short* nDirection3);
	void Add();
	void Edit();
	CString Update();
	void Delete();
	VARIANT GetData(short nField);
	void SetData(short nField, const VARIANT& newValue);
	void Jump(long nIndex);
	void Rebuild();
	void SetNoteFilter();
	void ClearNoteFilter();
	void SetHistoryFilter();
	void ClearHistoryFilter();
	void SetAttachmentFilter();
	void ClearAttachmentFilter();
	void SetContactScope(LPCTSTR sUniqueId);
	void ClearContactScope();
	void SetGroupScope(LPCTSTR sUniqueId);
	void ClearGroupScope();
	CString GetQuery();
	void SetQuery(LPCTSTR lpszNewValue);
	void Execute();
	void GetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	void SetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	BOOL GetStats(short nScopeType, LPCTSTR lpszUniqueId, const VARIANT& vFieldArray, const VARIANT& vValueArray, const VARIANT& vCountArray);
	void LookupKeyword(LPCTSTR sKeyword);
};
/////////////////////////////////////////////////////////////////////////////
// IUsers wrapper class

class IUsers : public COleDispatchDriver
{
public:
	IUsers() {}		// Calls COleDispatchDriver default constructor
	IUsers(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IUsers(const IUsers& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();
	BOOL GetError();
	short GetLastError();

// Operations
public:
	CString GetName(short nUser);
	CString GetUniqueId(short nUser);
	long GetAccess(short nUser);
	void SetAccess(short nUser, long nNewValue);
	long GetSecurity(short nUser);
	void SetSecurity(short nUser, long nNewValue);
	BOOL IsValidPassword(short nUser, LPCTSTR sPassword);
	void SetPassword(short nUser, LPCTSTR sOldPassword, LPCTSTR sNewPassword);
	CString GetPassword(short nUser);
	BOOL GetExists(LPCTSTR sUser);
	CString GetCurrentUserName();
	CString GetCurrentUserId();
	long GetCurrentUserSecurity();
	long GetCurrentUserAccess();
	BOOL SetAsPhonebook();
	BOOL CheckIsPhonebook();
	BOOL AddUser(LPCTSTR lpszUserName, LPCTSTR lpszPassword, short nSecurityLevel);
};
/////////////////////////////////////////////////////////////////////////////
// IFields wrapper class

class IFields : public COleDispatchDriver
{
public:
	IFields() {}		// Calls COleDispatchDriver default constructor
	IFields(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IFields(const IFields& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	BOOL GetError();
	short GetLastError();
	short GetCount();
	void SetCount(short);

// Operations
public:
	CString GetLabel(short nField);
	void SetLabel(short nField, LPCTSTR lpszNewValue);
	short GetLength(short nField);
	short GetType(short nField);
	void SetType(short nField, short nNewValue);
	CString GetInitialValue(short nField);
	void SetInitialValue(short nField, LPCTSTR lpszNewValue);
	short GetId(short nField);
	BOOL GetExists(LPCTSTR sField);
	BOOL GetIsIndexed(short nField);
	short GetDecimalPlaces(short nField);
	void SetDecimalPlaces(short nField, short nNewValue);
	long GetFlags(short nField);
	void SetFlags(short nField, long nNewValue);
	BOOL GetIsCutHistory(short nField);
	void SetIsCutHistory(short nField, BOOL bNewValue);
	BOOL GetIsPrimary(short nField);
	void SetIsPrimary(short nField, BOOL bNewValue);
	BOOL GetIsBlockSync(short nField);
	void SetIsBlockSync(short nField, BOOL bNewValue);
	long GetModifiable(short nField);
	BOOL GetIsSortable(short nField);
	CString GetEntryTrigger(short nField);
	void SetEntryTrigger(short nField, LPCTSTR lpszNewValue);
	CString GetExitTrigger(short nField);
	void SetExitTrigger(short nField, LPCTSTR lpszNewValue);
	LPDISPATCH GetPopupInfo(short nField, short nPopupIndex);
	BOOL GetHasPopupList(short nField);
	short GetFieldIdAt(short nPos);
	short GetFieldId(LPCTSTR lpszFieldName);
	short AddField(LPCTSTR pName, short type, long Length);
	BOOL DeleteField(short nField);
	short GetEntryRule(short nField);
	void SetEntryRule(short nField, short nNewValue);
	BOOL BeginBatch();
	BOOL EndBatch();
	BOOL GetAutoPopulate(short nField);
	void SetAutoPopulate(short nField, BOOL bNewValue);
	BOOL GetLinkToList(short nField, short* pnField, short* pnTable);
	BOOL SetLinkToList(short nField, short nLinkToField, short nLinkToTable);
	BOOL UnLinkLists(short nField, BOOL bCopyList);
};
/////////////////////////////////////////////////////////////////////////////
// IMembers wrapper class

class IMembers : public COleDispatchDriver
{
public:
	IMembers() {}		// Calls COleDispatchDriver default constructor
	IMembers(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IMembers(const IMembers& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetPosition();
	short GetFieldCount();
	BOOL GetError();
	short GetLastError();
	CString GetName();
	CString GetUniqueId();
	long GetRecordCount();
	BOOL GetIsBOF();
	BOOL GetIsEOF();
	LPDISPATCH GetFields();

// Operations
public:
	void MoveFirst();
	void MoveLast();
	void MoveNext();
	void MovePrevious();
	void GoTo(LPCTSTR sUniqueId);
	void Lookup(short nField, LPCTSTR sKeyword, short nlookupType);
	void Sort(short nField1, short nDirection1, short nField2, short nDirection2, short nField3, short nDirection3);
	short GetSort(short* nField1, short* nDirection1, short* nField2, short* nDirection2, short* nField3, short* nDirection3);
	VARIANT GetData(short nField);
	void SetData(short nField, const VARIANT& newValue);
	void Jump(long nIndex);
	void Rebuild();
	CString GetQuery();
	void SetQuery(LPCTSTR lpszNewValue);
	void Execute();
	void GetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	void SetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	BOOL GetStats(short nScopeType, LPCTSTR lpszUniqueId, const VARIANT& vFieldArray, const VARIANT& vValueArray, const VARIANT& vCountArray);
};
/////////////////////////////////////////////////////////////////////////////
// IPopupInfo wrapper class

class IPopupInfo : public COleDispatchDriver
{
public:
	IPopupInfo() {}		// Calls COleDispatchDriver default constructor
	IPopupInfo(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IPopupInfo(const IPopupInfo& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	BOOL GetError();
	short GetLastError();
	short GetPopupCount();

// Operations
public:
	CString GetRemark(short nIndex);
	CString GetValue(short nIndex);
	void Add(LPCTSTR Value, LPCTSTR Remark);
	void Clear();
	void Remove(short nIndex);
};
/////////////////////////////////////////////////////////////////////////////
// IExceptionInfo wrapper class

class IExceptionInfo : public COleDispatchDriver
{
public:
	IExceptionInfo() {}		// Calls COleDispatchDriver default constructor
	IExceptionInfo(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IExceptionInfo(const IExceptionInfo& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	BOOL GetError();
	short GetLastError();
	short GetCount();

// Operations
public:
	void Clear();
	void Seek(const VARIANT& exceptionDate);
	void Add(const VARIANT& exceptionDate);
	void Remove(const VARIANT& exceptionDate);
	VARIANT Value(short nIndex);
};
/////////////////////////////////////////////////////////////////////////////
// IRelations wrapper class

class IRelations : public COleDispatchDriver
{
public:
	IRelations() {}		// Calls COleDispatchDriver default constructor
	IRelations(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IRelations(const IRelations& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();

// Operations
public:
	short GetTable1ID(short nIndex);
	short GetColumn11ID(short nIndex);
	short GetTable2ID(short nIndex);
	short GetColumn2ID(short nIndex);
	short GetRelationType(short nIndex);
	BOOL UsesRelationTable(short nIndex);
};
/////////////////////////////////////////////////////////////////////////////
// ISales wrapper class

class ISales : public COleDispatchDriver
{
public:
	ISales() {}		// Calls COleDispatchDriver default constructor
	ISales(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	ISales(const ISales& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetPosition();
	CString GetName();
	BOOL GetIsOpen();
	short GetFieldCount();
	long GetRecordCount();
	BOOL GetIsLocked();
	short GetLockLevel();
	BOOL GetError();
	short GetLastError();
	BOOL GetIsBOF();
	BOOL GetIsEOF();
	LPDISPATCH GetFields();

// Operations
public:
	void Open();
	void Close();
	void MoveFirst();
	void MoveLast();
	void MoveNext();
	void MovePrevious();
	void GoTo(LPCTSTR sUniqueId);
	void Lookup(short nField, LPCTSTR sKeyword, short nlookupType);
	void Sort(short nField1, short nDirection1, short nField2, short nDirection2, short nField3, short nDirection3);
	short GetSort(short* nField1, short* nDirection1, short* nField2, short* nDirection2, short* nField3, short* nDirection3);
	void Add();
	void Edit();
	CString Update();
	void Delete();
	VARIANT GetData(short nField);
	void SetData(short nField, const VARIANT& newValue);
	void Jump(long nIndex);
	void Rebuild();
	CString GetQuery();
	void SetQuery(LPCTSTR lpszNewValue);
	void Execute();
	void GetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	void SetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	void AssociateWithContact(LPCTSTR sContactId);
	void AssociateWithGroup(LPCTSTR sGroupId);
	void CompleteSale(short nStatus, DATE closeDate, LPCTSTR sReason);
	void ReopenSale();
	void SetContactScope(LPCTSTR sContactId);
	void ClearContactScope();
	void SetGroupScope(LPCTSTR sGroupId);
	void ClearGroupScope();
};
/////////////////////////////////////////////////////////////////////////////
// IListTable wrapper class

class IListTable : public COleDispatchDriver
{
public:
	IListTable() {}		// Calls COleDispatchDriver default constructor
	IListTable(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IListTable(const IListTable& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	long GetPosition();
	CString GetName();
	BOOL GetIsOpen();
	short GetFieldCount();
	long GetRecordCount();
	BOOL GetIsLocked();
	short GetLockLevel();
	BOOL GetError();
	short GetLastError();
	BOOL GetIsBOF();
	BOOL GetIsEOF();
	LPDISPATCH GetFields();
	short GetItemType();
	void SetItemType(short);
	CString GetItemName();
	void SetItemName(LPCTSTR);

// Operations
public:
	void Open();
	void Close();
	void MoveFirst();
	void MoveLast();
	void MoveNext();
	void MovePrevious();
	void GoTo(LPCTSTR sUniqueId);
	void Lookup(short nField, LPCTSTR sKeyword, short nlookupType);
	void Sort(short nField1, short nDirection1, short nField2, short nDirection2, short nField3, short nDirection3);
	short GetSort(short* nField1, short* nDirection1, short* nField2, short* nDirection2, short* nField3, short* nDirection3);
	void Add();
	void Edit();
	CString Update();
	void Delete();
	VARIANT GetData(short nField);
	void SetData(short nField, const VARIANT& newValue);
	void Jump(long nIndex);
	void Rebuild();
	CString GetQuery();
	void SetQuery(LPCTSTR lpszNewValue);
	void Execute();
	void GetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	void SetDataEx(const VARIANT& vFieldArray, const VARIANT& vValueArray);
	void SetScope(short nTypeScope);
	short GetScope();
	void ClearScope();
	CString FindName(LPCTSTR sItemName);
};
